package cz.muni.fi.pb162.task1;

/**
 * The test class FirstClassTest.
 *
 * @author  Petr Adamek, xadamek2@fi.muni.cz
 * @version 15.07.2005
 */
public class FirstClassTest extends junit.framework.TestCase
{

    /**
     * Default constructor for test class FirstClassTest
     */
    public FirstClassTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testSampleMethod() throws IllegalAccessException
    {
        cz.muni.fi.pb162.task1.FirstClass firstCla1 = new cz.muni.fi.pb162.task1.FirstClass();
        assertEquals("Metoda sampleMethod nevrac\u00ed o\u010dek\u00e1vanou hodnotu ",123, firstCla1.sampleMethod(123));
        
        // Nasledujici radky uzivaji velmi pokrocile konstrukce 
        // takze si je radeji ani neprohlizejte, abyste se zbytecne
        // nedesili :-). Navic jde o velmi osklive reseni,
        // ktere by se normalne pouzivat nemelo!
        
        try {
            java.lang.reflect.Field xField = FirstClass.class.getDeclaredField("x");
            assertEquals("Atribut x t\u0159\u00eddy FirstClass nen\u00ed typu int",Integer.TYPE,xField.getType());
            xField.setAccessible(true);
            xField.setInt(firstCla1,-112);
            assertEquals(123 - 112, firstCla1.sampleMethod(123));
        } catch(NoSuchFieldException ex) {
            fail("T\u0159\u00edda FirstClass neobsahuje atribut x");
        }
        
    }
}

